﻿//Author : Umakanthan Chandran
//email : cumakt@gmail.com
//GPL License

var oldHash;
var url;
var newGadgets = "New Gadget Updates in Google Desktop Gallery page";
var noGadgets = "No Gadget Updates in Google Desktop Gallery page";
var selectedIntervalName = "";
var selectedInterval = "100000";
SetDefaultOptions();
var intervalNames = new Array("Every Day ","2 Days","3 Days","4 Days","5 Days","6 Days","Every Week");
var intervalCodes = new Array("86400","172800","259200","345600","432000"," 518400","604800");
plugin.onShowOptionsDlg = ShowOptionsDlg;
function SetDefaultOptions()
{
    if (options.exists("intervalname"))
    selectedIntervalName = options("intervalname");
    else
    options("intervalname") = selectedIntervalName;
    if (options.exists("intervalcode"))
    selectedInterval = options("intervalcode");
    else
    options("intervalcode") = selectedInterval;
}
function GetselectedIntervalName()
{
    var ctr = selectedInterval;
    var i = 0;
    for(i=0;i<intervalNames.length;i++)
    {
        if(intervalNames[i]==ctr)
        break;
    }
    return intervalCodes[i];
}
function ShowOptionsDlg(wnd)
{
    wnd.AddControl(gddWndCtrlClassLabel, 0, "", "Choose days to check for New Gadgets", 10, 10, 280, 30);
    var list = wnd.AddControl(gddWndCtrlClassList, gddWndCtrlTypeListDrop, "intervalcode", intervalNames, 10, 35, 280, 2000);
    list.value = selectedInterval;
    wnd.onClose = OptionsDlgClosed;
}
function OptionsDlgClosed(wnd, code)
{
    if (code == gddIdOK)
    {
        var list = wnd.GetControl("intervalcode");
        selectedInterval = list.value;
        selectedIntervalName = GetselectedIntervalName();
        options("intervalcodecode") = selectedIntervalName;
        options("intervalcode") = selectedInterval;
        setInterval(load,selectedIntervalName);
    }
}
function view_onOpen()
{
    load();
}
function load()
{
    img3.visible = false;
    img5.visible = false;
    view.height = 120;
    oldHash = options.getValue("prevHash");
    url = "http://desktop.google.com/plugins";
    //url = "http://desktop.google.com/plugins/?p=1";
    sendXmlHttpRequest(url);
}
var isChecking = false;
function sendXmlHttpRequest(url)
{
    if(!isChecking)
    {
        isChecking = true;
        http = new XMLHttpRequest();
        http.onreadystatechange = onReqDone;
        l.src = "connecting.png";
        status.innerText = "Connecting ...";
        http.open("GET", url, true);
        try
        {
            http.send();
        }
        catch(e)
        {
        }
    }
}
function normal()
{
    l.src = srcImg;
    status.innerText = srcTxt;
    img1.visible = true;
    img2.visible = true;
    img1.src = srcImg;
    img2.src = srcImg;
    status.color = statusColor;
}
function allImg()
{
    img1.visible = true;
    img2.visible = true;
    img1.src = srcImg;
    img2.src = srcImg;
}
function noImg()
{
    img1.visible = false;
    img2.visible = false;
}
function change()
{
    noImg();
    l.src ="lurking.png";
    status.color = "#FFFFFF";
    status.innerText = "Click to Check ...";
}
var srcImg;
var srcTxt;
var httpSrc;
var statusColor;
function onReqDone()
{
    if(4 == http.readyState)
    {
        if ( http.status == 200 )
        {
            httpSrc = http.responseText;
            var newHash = hash(http.responseText);
            if(oldHash.length > 0 )
            {
                if(oldHash == newHash )
                {
                    l.src ="error.png"
                    srcImg = l.src;
                    status.innerText = noGadgets;
                    status.color="#FF1100";
                    statusColor = status.color;
                    srcTxt = status.innerText;
                    allImg();
                    hideShow();
                    img3.visible = false;
                    img4.visible = false;
                }
                else
                {
                    l.src = "connected.png";
                    srcImg = l.src;
                    status.innerText = newGadgets;
                    srcTxt = status.innerText;
                    statusColor = status.color;
                    status.color="#79B643";
                    allImg();
                    enableView();
                    display(httpSrc);
                }
            }
            else
            {
                l.src = "connected.png";
                srcImg = l.src;
                status.innerText = newGadgets;
                srcTxt = status.innerText;
                statusColor = status.color;
                status.color="#79B643";
                allImg();
                enableView();
                display(httpSrc);
            }
            isChecking = false;
            options.putValue("prevHash", newHash);
        }
        else
        {
            l.src = "nolink.png";
            srcImg = l.src;
            status.color="#FFFFFF";
            status.innerText = "Net Failure";
            srcTxt = status.innerText;
        }
    }
}
var initSrc,parse1,parse2;
var parse1 = new Array();
var parseName = new Array();

var parseImg = new Array();

var nxt = parseInt('1');
var imgNxt = parseInt('25');

function doNext() {
    if (imgNxt == 25) { prevGadget.visible = false; nextGadget.visible = true; }
    if(imgNxt == 48) { prevGadget.visible = true; nextGadget.visible = false; }
     nameG.innerText = parseName[nxt];
     imgSourceReq(parseImg[imgNxt]); 
     nxt = nxt + 1;     
     imgNxt = imgNxt + 1; 
     prevGadget.visible = true;
}


function doPrev() {
if( imgNxt == 48 ) { prevGadget.visible = true; nextGadget.visible = false; }
if (imgNxt == 25) { prevGadget.visible = false; nextGadget.visible = true; }
          nameG.innerText = parseName[nxt];
          imgSourceReq(parseImg[imgNxt]); 
	        nxt = nxt - 1;     
          imgNxt = imgNxt - 1;
          nextGadget.visible = true;
}


function display(httpSrc)
{
    initSrc = generic_find(httpSrc,"All Google Desktop Gadgets","All Google Desktop Gadgets","Much of the content in this directory");
    newSrc = replace(initSrc, "<td align=\"center\" valign=\"bottom\"> <a href=\"/plugins/i/","<checkMate");
    for(i=1; i <=j ; i++) {
     parse1[i] = generic_find(newSrc,"<checkMate" + i + ">" ,"<checkMate" + i + ">","<br>");
     parseName[i] = generic_find(parse1[i] ,"\">","\">","</a>"); 
    }
    newImg = replace(initSrc,"<img width=\"80\"","<imageCheck");
    for(i=25; i <=48 ; i++) {
      parseImg[i] = generic_find(newImg,"<imageCheck" + i + ">","src=\"","\" border=");
      parseImg[i]  = "http://desktop.google.com" +  parseImg[i] ;
     }
}

function imgSourceReq(imgUrl)
 {
    logoRequest_ = new XMLHttpRequest();
    try
    {
        logoRequest_.open("GET", imgUrl, true);
    }
    catch (e)
    {
        logoRequest_ = null;
        return;
    }
    logoRequest_.onreadystatechange = onLogoData;
    try
    {
        logoRequest_.send();
    }
    catch (e)
    {
        logoRequest_ = null;
        return;
    }
}
function onLogoData()
{
    if (logoRequest_.readyState != 4)
    return;
    if (logoRequest_.status != 200)
    {
        logoRequest_ = null;
        return;
    }
    img6.src = logoRequest_.responseStream;
    logoRequest_ = null;
}
function countInstances(string, word)
{
    var substrings = string.split(word);
    return substrings.length - 1;
}

var j= parseInt("0");
function replace(s, t, u) {
  i = s.indexOf(t);
  r = "";
  if (i == -1) return s;
  r += s.substring(0,i) + u + (++j) +">" ;
  if ( i + t.length < s.length) {
    r += replace(s.substring(i + t.length, s.length), t, u);
    }
    return r;
  }
  
function generic_find(word,start,startIndexWord,endIndexWord)
{
    var searc = start;
    var matches = word.search(searc);
    if (matches == -1)
    {
        return "No Match Found";
    }
    var matchedString = word.substring(matches, word.length);
    var startIndex = matchedString.indexOf(startIndexWord) + startIndexWord.length;
    var endIndex = matchedString.indexOf(endIndexWord);
    var define = matchedString.substring(startIndex, endIndex);
    return define;
}
function gotoGallery()
{
}
function expandShow()
{
    view.height = 240;
    img3.visible = false;
    img5.visible = true;
    nameG.innerText = parseName[nxt];
    imgSourceReq(parseImg[imgNxt]); 
    nxt = nxt + 1;     
    imgNxt = imgNxt + 1; 
    prevGadget.visible = true;
}
function hideShow()
{
    view.height = 120;
    img3.visible = true;
    img5.visible = false;
}
function enableView()
{
    img3.visible = true;
}
function checkAndClick()
{
    if(status.innerText == "New Gadgets")
    {
        status.tooltip = "Click to Open";
    }
    if(status.innerText =="Click to Check ...")
    {
        load();
    }
}
function showPage()
{
    debug.trace(httpSrc);
    debug.trace(httpSrc.length);
    var htmlDetailsView = new DetailsView();
    var htmlContent = httpSrc;
    htmlContent += "</body></html>";
    htmlDetailsView.html_content = true;
    htmlDetailsView.setContent(undefined, undefined, htmlContent, false, 1);
    pluginHelper.showDetailsView(htmlDetailsView, "Google Desktop Gadgets",
    gddDetailsViewFlagToolbarOpen, onDetailsViewFeedback);
}
function onDetailsViewFeedback(detailsViewFlags)
{
    if (detailsViewFlags == gddDetailsViewFlagNone)
    {
    }
    else if (detailsViewFlags == gddDetailsViewFlagToolbarOpen)
    {
    }
}

function changePrevImage() {
   prevGadget.src = "prev_a.gif";
}

function normalPrevImage() {
  prevGadget.src = "prev_d.gif";
}

function changeNextImage() {
   nextGadget.src = "next_a.gif";
}

function normalNextImage() {
nextGadget.src = "next_d.gif";
}


function changeUp() {
   img5.src = "up1.gif";
}

function normalUp() {
   img5.src = "up.gif";
}

function changeDown() {
   img3.src = "down1.gif";
}

function normalDown() {
img3.src = "down.gif";
}

/*
Hashing script by Chris Veness
http://www.movable-type.co.uk/scripts/SHA-1.html
See below for the source code of the JavaScript implementation.
You are welcome to re-use these scripts [without any warranty express or implied] provided you
retain my copyright notice and when possible a link to my website. If you have any queries
or find any problems, please contact me.
© 2002-2005 Chris Veness
*/



function hash(s)
{
    return sha1Hash(s);
}
function sha1Hash(msg)
{
    var K = [0x5a827999, 0x6ed9eba1, 0x8f1bbcdc, 0xca62c1d6];
    msg += String.fromCharCode(0x80);
    var l = Math.ceil(msg.length/4) + 2;
    var N = Math.ceil(l/16);
    var M = new Array(N);
    for (var i=0; i<N; i++)
    {
        M[i] = new Array(16);
        for (var j=0; j<16; j++)
        {
            M[i][j] = (msg.charCodeAt(i*64+j*4)<<24) | (msg.charCodeAt(i*64+j*4+1)<<16) |
            (msg.charCodeAt(i*64+j*4+2)<<8) | (msg.charCodeAt(i*64+j*4+3));
        }
    }
    M[N-1][14] = ((msg.length-1) >>> 30) * 8;
    M[N-1][15] = ((msg.length-1)*8) & 0xffffffff;
    var H0 = 0x67452301;
    var H1 = 0xefcdab89;
    var H2 = 0x98badcfe;
    var H3 = 0x10325476;
    var H4 = 0xc3d2e1f0;
    var W = new Array(80);
    var a, b, c, d, e;
    for (var i=0; i<N; i++)
    {
        for (var t=0; t<16; t++) W[t] = M[i][t];
        for (var t=16; t<80; t++) W[t] = ROTL(W[t-3] ^ W[t-8] ^ W[t-14] ^ W[t-16], 1);
        a = H0;
        b = H1;
        c = H2;
        d = H3;
        e = H4;
        for (var t=0; t<80; t++)
        {
            var s = Math.floor(t/20);
            var T = (ROTL(a,5) + f(s,b,c,d) + e + K[s] + W[t]) & 0xffffffff;
            e = d;
            d = c;
            c = ROTL(b, 30);
            b = a;
            a = T;
        }
        H0 = (H0+a) & 0xffffffff;
        H1 = (H1+b) & 0xffffffff;
        H2 = (H2+c) & 0xffffffff;
        H3 = (H3+d) & 0xffffffff;
        H4 = (H4+e) & 0xffffffff;
    }
    return H0.toHexStr() + H1.toHexStr() + H2.toHexStr() + H3.toHexStr() + H4.toHexStr();
}
function f(s, x, y, z)
{
    switch (s)
    {
        case 0: return (x & y) ^ (~x & z);
        case 1: return x ^ y ^ z;
        case 2: return (x & y) ^ (x & z) ^ (y & z);
        case 3: return x ^ y ^ z;
    }
}
function ROTL(x, n)
{
    return (x<<n) | (x>>>(32-n));
}

/*
   extend Number class with a tailored hex-string method 
   (note toString(16) is implementation-dependant, and 
   in IE returns signed numbers when used on full words)
*/

Number.prototype.toHexStr = function()
{
    var s="", v;
    for (var i=7; i>=0; i--)
    {
        v = (this>>>(i*4)) & 0xf;
        s += v.toString(16);
    }
    return s;
}
